
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from taskbarbuttonhighlightwalkto import *
from taskbarbuttonhighlightlookat import *
from taskbarbuttonhighlighttalkto import *

class Taskbar:
    "Taskbar"
    def __init__(self, screen, font):
        self.screen = screen	
        self.font = font
        self.background = pygame.image.load('./pics/blank-grey.png').convert()
        self.background.set_colorkey((0,0,255)) 
       
	### taskbar widgets
	self.walkto = TaskbarButtonHighlightWalkTo(screen, font) 
	self.lookat = TaskbarButtonHighlightLookAt(screen, font) 
	self.talkto = TaskbarButtonHighlightTalkTo(screen, font) 
 
    def collide(self,xx,yy):
	if (self.walkto.collide(xx,yy)):
		return (self.walkto, 1)
	if (self.lookat.collide(xx,yy)):
		return (self.lookat, 2)
	if (self.talkto.collide(xx,yy)):
		return (self.talkto, 9)
	return None

    def highlight(self):
	if "highlight" in dir(self.walkto):	
		self.walkto.highlight()
	if "highlight" in dir(self.lookat):	
		self.lookat.highlight()
	if "highlight" in dir(self.talkto):	
		self.talkto.highlight()

    def unhighlight(self):
	if "unhighlight" in dir(self.walkto):	
		self.walkto.unhighlight()
	if "unhighlight" in dir(self.lookat):	
		self.lookat.unhighlight()
	if "unhighlight" in dir(self.talkto):	
		self.talkto.unhighlight()

    def draw(self):
        self.screen.blit(self.background, (0, 310))
	self.walkto.draw()
	self.lookat.draw()
	self.talkto.draw()
